#pragma config(Sensor, S1,     leftSonar,      sensorEV3_Ultrasonic)
#pragma config(Sensor, S2,     leftColor,      sensorEV3_Color)
#pragma config(Sensor, S3,     rightColor,     sensorEV3_Color)
#pragma config(Sensor, S4,     rightSonar,     sensorEV3_Ultrasonic)
#pragma config(Motor,  motorB,          ruleMotor,     tmotorEV3_Large, openLoop, encoder)
#pragma config(Motor,  motorC,          speedMotor,    tmotorEV3_Large, openLoop, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

int e, alpha, alphaNew=0, state=0, lastState=0, per=0, v=80, stE=0, center=0;
int leftBlack=0, leftWhite=0, rightBlack=0, rightWhite=0, leftGrey=0, rightGrey=0;
const int corB=5, corBLine=2, kAlpha=15, kA=10, timePer=1500, tLines=8000, timeZero=4000;
const float kRule=1, kRuleLine=2, batteryPower=8;

void powerControl()
{

	while(getBatteryVoltage()<batteryPower)
	{
		displayCenteredBigTextLine(3, "Power=%.2f", getBatteryVoltage());
		displayCenteredBigTextLine(5, "LOW Battery,");
		displayCenteredBigTextLine(7, "please replace or");
		displayCenteredBigTextLine(9, "charge the battery");
		sleep(1);
	}
	eraseDisplay();
}

void calibr()
{
	displayCenteredBigTextLine(3, "Put the left");
	displayCenteredBigTextLine(5, "color sensor on");
	displayCenteredBigTextLine(7, "white and press");
	displayCenteredBigTextLine(9, "the left button");
	while(!getButtonPress(buttonLeft))
		sleep(1);
	leftWhite=SensorValue[leftColor];
	playSound(soundBeepBeep);

	displayCenteredBigTextLine(3, "Put the right");
	displayCenteredBigTextLine(5, "color sensor on");
	displayCenteredBigTextLine(7, "white and press,");
	displayCenteredBigTextLine(9, "the right button");
	while(!getButtonPress(buttonRight))
		sleep(1);
	rightWhite=SensorValue[rightColor];
	playSound(soundBeepBeep);

	displayCenteredBigTextLine(3, "Put the left");
	displayCenteredBigTextLine(5, "color sensor on");
	displayCenteredBigTextLine(7, "black and press");
	displayCenteredBigTextLine(9, "the left button");
	while(!getButtonPress(buttonLeft))
		sleep(1);
	leftBlack=SensorValue[leftColor];
	playSound(soundBeepBeep);

	displayCenteredBigTextLine(3, "Put the right");
	displayCenteredBigTextLine(5, "color sensor on");
	displayCenteredBigTextLine(7, "black and press,");
	displayCenteredBigTextLine(9, "the right button");
	while(!getButtonPress(buttonRight))
		sleep(1);
	rightBlack=SensorValue[rightColor];
	playSound(soundBeepBeep);

	leftGrey=(leftWhite+leftBlack)/2;
	rightGrey=(rightWhite+rightBlack)/2;
	stE=leftGrey-rightGrey;

	eraseDisplay();
	displayCenteredBigTextLine(5, "Press Enter");
	displayCenteredBigTextLine(7, "and wait for");
	displayCenteredBigTextLine(9, "the signal");
	while(!getButtonPress(buttonEnter))
		sleep(1);

	motor[ruleMotor]=-10;
	sleep(2000);
	motor[ruleMotor]=0;
	nMotorEncoder[ruleMotor]=0;

	motor[ruleMotor]=10;
	sleep(3000);
	motor[ruleMotor]=0;
	center=nMotorEncoder[ruleMotor]/2;

	motor[ruleMotor]=-10;
	while(nMotorEncoder[ruleMotor]!=center)
		sleep(1);
	motor[ruleMotor]=0;
	playSound(soundBeepBeep);

	displayCenteredBigTextLine(5, "Put the robot");
	displayCenteredBigTextLine(7, "on the track");
	displayCenteredBigTextLine(9, "and press Enter");
	while(!getButtonPress(buttonEnter))
		sleep(1);
}

task moveRobot()
{
	while(true)
	{
		e=SensorValue[rightSonar]-SensorValue[leftSonar];
		if (abs(e)>100)
			alpha=center+sgn(e)*center;
		else
			alpha=center+e/2;

		alphaNew=alphaNew+sgn(alpha-alphaNew)*kAlpha;
		motor[ruleMotor]=(alphaNew-nMotorEncoder[ruleMotor])*kRule;
		motor[speedMotor]=v;
		sleep(50);
		displayCenteredBigTextLine(1, "S2=%d", SensorValue[leftColor]);
		displayCenteredBigTextLine(3, "S3=%d", SensorValue[rightColor]);
		displayCenteredBigTextLine(7, "blackL=%d", leftBlack);
		displayCenteredBigTextLine(9, "blackR=%d", rightBlack);
		displayCenteredBigTextLine(13, "per=%d", per);
		if(time1[T3]>timeZero)
			per=0;
	}
}

void stopLine()
{
	displayCenteredBigTextLine(5, "Stop Line");
	playSound(soundBeepBeep);
	while(SensorValue[leftColor]>leftBlack+corB && SensorValue[rightColor]>rightBlack+corB)
		sleep(1);
	stopTask(moveRobot);
	motor[speedMotor]=0;
	motor[ruleMotor]=0;
	sleep(200);
	startTask(moveRobot);
	while(SensorValue[leftColor]<leftBlack+corB && SensorValue[rightColor]<rightBlack+corB)
		sleep(1);
}
/*
void rocks()
{
sleep(2000);
motor[speedMotor]=v/2;
sleep(1000);
motor[speedMotor]=v;
}
*/

void lines()
{
	while(SensorValue[rightColor]>rightBlack+corBLine)
		sleep(1);

	stopTask(moveRobot);
	displayCenteredBigTextLine(5, "Lines");
	playSound(soundException);
	clearTimer(T2);
	while(time1[T2]<tLines)
	{
		e=SensorValue[leftColor]-SensorValue[rightColor];
		alpha=center+e;
		alphaNew+=sgn(alpha-alphaNew)*kA;

		motor[ruleMotor]=(alphaNew-nMotorEncoder[ruleMotor])*kRuleLine;
		motor[speedMotor]=v/2;
		sleep(50);
	}
	startTask(moveRobot);
}

void perekr()
{
	displayCenteredBigTextLine(5, "run");
	if(SensorValue[leftColor]<leftBlack+corB && SensorValue[rightColor]<rightBlack+corB)
		state=1;
	else
		state=0;
	if(state==1 && state!=lastState)
	{
		per++;
		clearTimer(T1);
		clearTimer(T3);
	}
	lastState=state;
	sleep(1);
}

int readLines()
{
	per=0;
	while(per<3)
		perekr();

	v/=2;
	while(time1(T1)<timePer)
		perekr();

	v*=2;
	if(per==3)
		return 3;
	else if(per==4)
		return 3;
	else if(per==5)
		return 3;
	else if(per==6)
		return 1;
	else if(per==7)
		return 1;
	else
		return 0;
}

task main()
{
	powerControl();
	calibr();

	eraseDisplay();
	startTask(moveRobot);

	while(true)
	{
		switch(readLines())
		{
		case 1:
			stopLine();
			break;

		case 3:
			lines();
			break;

		default:
			playSound(soundDownwardTones);
			break;
		}
	}
}
